
;Alpha Strip - DednDave, 3-2012

        .MODEL  Small
        .DOSSEG                     ;DOS segment order
        .STACK  1024
        OPTION  CaseMap:None        ;case sensitive

;####################################################################

BUFSIZE EQU 99                      ;user input buffer size, 255 max

;####################################################################

INBUFFER  STRUCT
  MaxBytes  db ?
  UsedBytes db ?
  Buffer    db BUFSIZE+1 dup(?)
INBUFFER  ENDS

;####################################################################

        .DATA

s$Prompt1 db 'Enter a String: ',24h
s$AnyKey  db 0Dh,0Ah,'Press Any Key To Exit',24h
s$CrLf    db 0Dh,0Ah,24h

OutBuf    db 5 dup(?),24h

;********************************************************************

        .DATA?

InpBuf  INBUFFER <>

;####################################################################

        .CODE

;********************************************************************

_main   PROC    FAR

;------------------------------------------

;set DS, ES to DGROUP

        ASSUME  DS:DGROUP

        mov     ax,@data
        mov     ds,ax
        mov     es,ax

;------------------------------------------

;initialize input buffer size

        mov    InpBuf.MaxBytes,BUFSIZE+1

;------------------------------------------

;get user input string

        call    NewLine
        mov     dx,offset s$Prompt1 ;'Enter a String:'
        mov     ah,9
        int     21h
        mov     dx,offset InpBuf
        mov     ah,0Ah
        int     21h
        call    NewLine

;------------------------------------------

;filter the string

;0        null (white space)
;20h      space
;41h-5Ah  A-Z
;61h-7Ah  a-z

        mov     dx,offset InpBuf.Buffer
        xor     bx,bx
        mov     cl,InpBuf.UsedBytes
        mov     ch,bl
        mov     si,dx
        mov     di,dx
        jcxz    Loop03

Loop00: lodsb
        mov     ah,al
        and     ah,0DFh            ;clear bit 5 - forces upper case
        jz      Loop01             ;if it's 0 or 20h - white space

        cmp     ah,'A'
        jb      Loop02

        cmp     ah,'Z'
        ja      Loop02

Loop01: stosb
        inc     bx                  ;count it in BX

Loop02: loop    Loop00

Loop03: mov     al,'$'
        stosb

;display the string

        call    StrOut

;display the char count

        mov     ax,bx
        call    UnsDec
        call    StrOut

;------------------------------------------

;wait for a key press

Exit00: mov     dx,offset s$AnyKey  ;'Press Any Key To Exit'
        call    StrOut
        mov     ah,1                ;wait for key
        int     16h                 ;BIOS keyboard call
        mov     ah,0                ;get keyboard character
        int     16h                 ;BIOS keyboard call

;------------------------------------------

;terminate program

        mov     ax,4C00h            ;terminate, return = 0
        int     21h                 ;DOS function call

_main   ENDP

;********************************************************************

StrOut  PROC    NEAR
;
;Display a String Followed by Carriage Return/Line Feed
;
;Call With: DX = address of '$' terminated string to display
;
;  Returns: Nothing
;
;     Uses: AX, DX are destroyed, all other registers are preserved
;
;------------------------------------------

        mov     ah,9
        int     21h

NewLine::
        mov     dx,offset s$CrLf
        mov     ah,9
        int     21h
        ret

StrOut  ENDP

;********************************************************************

UnsDec  PROC    NEAR
;
;Convert a 16-Bit Unsigned Integer to ASCII Decimal String
;
;Call With: AX = unsigned binary integer
;
;  Returns: DX = DI = address of '$'-terminated ASCII decimal string
;
;Also Uses: AX, CX also destroyed, BX, SI, BP are preserved
;           the "OutBuf" buffer is used to hold the string
;
;------------------------------------------

        mov     di,offset OutBuf+sizeof OutBuf-1
        mov     cx,10               ;BX = divisor

UnDec0: xor     dx,dx               ;zero the high word
        dec     di                  ;point to next string byte
        div     cx                  ;divide DX:AX by 10
        or      dl,30h              ;set ASCII bits in remainder
        mov     [di],dl             ;store the numeric character
        or      ax,ax               ;any quotient left ?
        jnz     UnDec0              ;loop until done

        mov     dx,di
        ret

UnsDec  ENDP

;####################################################################

        END     _main

